#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

const int N = 1024;

vector<int> graphList[N];
int n, m, q;
int pred[N];

int GetRoot(int i)
{
    int r, save;
    r = i;
    while (-1 != pred[r])
    {
        r = pred[r];
    }

    while (i != r)
    {
        save = i;
        i = pred[i];
        pred[save] = r;
    }
    
    return r;
}

void Input()
{
    scanf("%d%d", &n, &m);
    for (int i = 0; i < m; i++)
    {
        int u, v;
        scanf("%d%d", &u, &v);
        graphList[u].push_back(v);
        graphList[v].push_back(u);
        
        int r1 = GetRoot(u);
        int r2 = GetRoot(v);
        if (r1 != r2)
        {
            pred[r2] = r1;
        }
    }
    scanf("%d", &q);
}

int main()
{
    for (int i = 1; i < N; i++)
    {
        pred[i] = -1;
    }
    Input();
    
    for (int i = 0; i < q; i++)
    {
        int command, u, v;
        scanf("%d%d%d", &command, &u, &v);
        int r1 = GetRoot(u);
        int r2 = GetRoot(v);
        
        if (command == 1)
        {
            //check path from U to V
            //printf("roots: %d %d\n", r1, r2);
            if (r1 == r2)
            {
                printf("1");
            }
            else
            {
                printf("0");
            }
        }
        else if (command == 2)
        {
            // U <-> V = 1
            graphList[u].push_back(v);
            graphList[v].push_back(u);
            
            if (r1 != r2)
            {
                pred[r2] = r1;
            }
        }
        else
        {
            // U <-> V = 0
            for (int j = 0; j < graphList[u].size(); j++)
            {
                int e = graphList[u][j];
                //printf("%d", e);
                if (e == v)
                {
                    swap(graphList[u][j], graphList[u][graphList[u].size() - 1]);
                    graphList[u].pop_back();
                }
            }
            for (int j = 0; j < graphList[v].size(); j++)
            {
                int e = graphList[v][j];
               // printf("%d", e);
                if (e == u)
                {
                    swap(graphList[v][j], graphList[v][graphList[v].size() - 1]);
                    graphList[v].pop_back();
                }
            }
            
            if (graphList[u].size() == 0)
            {
                pred[u] = -1;
            }
            
            if (graphList[v].size() == 0)
            {
                pred[v] = -1;
            }
        }
    }
    printf("\n");
    /*
    for (int i = 1; i <= n; i++)
    {
        printf("%d -> %d\n", i, pred[i]);
    }
    
    for (int i = 1; i <= n; i++)
    {
        printf("%d: ", i);
        for (int j = 0; j < graphList[i].size(); j++)
        {
            printf("%d ", graphList[i][j]);
        }
        printf("\n");
    }*/
    
    return 0;
}