#include <cstdio>
#include <queue>

using namespace std;

int components[1001];
int a[1001][1001];
bool visited[1001];
int numberOfElementsInComponent[1001];
int neiX[1001];
int neiY[1001];
int numberX=0;
int numberY=0;
queue<int> q;

int n, Q, m, currentComponent=1;

void input1()
{
    scanf("%d%d", &n, &m);
    int x, y;
    for(int i=0; i<m; i++)
    {
        scanf("%d%d", &x, &y);
        a[x][y]=1;  a[y][x]=1;
    }
}

void initialization()
{
    for(int t=1; t<=n; t++)
    {
        if(visited[t] == false)
        {
            q.push(t);
            while(!q.empty())
            {
                int i=q.front();
                //printf("%d ", i);
                components[i] = currentComponent;
                numberOfElementsInComponent[currentComponent]++;
                q.pop();
                for(int j=1; j<=n; j++)
                {
                    if(a[i][j] == 1 && visited[j] == false)
                    {
                        q.push(j);
                        visited[j]=true;
                    }
                }
                
            }
            currentComponent++;
        }
    }
}

void input2()
{
    scanf("%d", &Q);
    int order, x, y;
    
    for(int i=0; i<Q; i++)
    {
        scanf("%d%d%d", &order, &x, &y);
        if(order == 1)
        {
            if(components[x] == components[y])
                printf("1");
            else
                printf("0");
        }
        
        if(order == 2)
        {
            a[x][y]=1;
            a[y][x]=1;
            if(components[x] != components[y])
            {
                if(numberOfElementsInComponent[components[x]] > numberOfElementsInComponent[components[y]])
                {
                    numberOfElementsInComponent[components[x]]+=numberOfElementsInComponent[components[y]];
                    numberOfElementsInComponent[components[y]]=0;
                    for(int p=1; p<=n; p++)
                        if(components[p] == components[y])
                            components[y] = components[x];
                }
                else
                {
                    numberOfElementsInComponent[components[y]]+=numberOfElementsInComponent[components[x]];
                    numberOfElementsInComponent[components[x]]=0;
                    for(int p=1; p<=n; p++)
                        if(components[p] == components[x])
                            components[x] = components[y];
                }
            }
        }
        
        if(order == 3)
        {
            numberX=0;
            numberY=0;
            a[x][y]=0;
            a[y][x]=0;
            bool notCritical=false;
            for(int i=0; i<=n; i++)
                visited[i]=false;
            
            q.push(x);
            int pos=1;
            while(!q.empty())
            {
                int front=q.front();
                if(front == y)
                {
                    notCritical=true;
                    while(!q.empty())
                        q.pop();
                }
                else
                {
                    neiX[pos]=front;
                    pos++;
                    q.pop();
                    for(int j=1; j<=n; j++)
                    {
                        if(a[front][j] == 1 && visited[j] == false)
                        {
                            q.push(j);
                            visited[j]=true;
                            numberX++;
                            
                        }
                    }
                }
            }
            if(notCritical == false)
            {
                for(int i=0; i<=n; i++)
                    visited[i]=false;
                pos=1;
                q.push(y);
                while(!q.empty())
                {
                    int front = q.front();
                    neiY[pos]=front;
                    pos++;
                    q.pop();
                    for(int j=1; j<=n; j++)
                    {
                        if(a[front][j] == 1 && visited[j] == false)
                        {
                            q.push(j);
                            visited[j]=true;
                            numberY++;
                        }
                    }

                }

                if(numberX < numberY)
                {
                    numberOfElementsInComponent[currentComponent] = numberX;
                    int r=1;
                    components[x]=currentComponent;
                    while(r<=numberX)
                    {
                        components[neiX[r]] = currentComponent;
                        r++;
                    }
                    currentComponent++;
                }
                else
                {
                    numberOfElementsInComponent[currentComponent] = numberY;
                    int r=1;
                    components[y]=currentComponent;
                    while(r<=numberY)
                    {
                        components[neiY[r]] = currentComponent;
                        r++;
                    }
                }
            }
        }
    }
}

int main()
{
    input1();
    initialization();
    
    //printf("\n\n  TUK ->%d\n\n", currentComponent);
    input2();
    /*printf("\n");
    for(int i=1; i<=n; i++)
        printf("%d ", components[i]); */
    return 0;
}

/*
9 8
1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9
8
1 1 8
1 6 2
2 7 1
1 4 7
2 2 3
1 4 7
3 3 4
1 4 7
*/


/*
9 8
1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9
9
1 1 8
1 6 2
2 7 1
1 4 7
2 2 3
1 4 7
3 2 3
1 4 7
1 3 4

*/