#include <cstdio>

using namespace std;

int a[1006][1006];

int n,mat[1006][1006],par[1006],rank[1006];

inline int root(const int &x)
{
    int y = x,rt,oth;
    while ( par[y] ) y = par[y];
    rt = y;
    y = x;
    while ( par[y] )
    {
        oth = par[y];
        par[y] = rt;
        y = oth;
    }

    return rt;
}

inline void unite(const int &x, const int &y)
{
    if ( rank[x] > rank[y] ) par[y] = x;
    else if ( rank[x] < rank[y] ) par[x] = y;
    else
    {
        par[x] = y;
        rank[y]++;
    }
}

int used[1006];

int q[1006];

inline void bfs(const int &x)
{
    int neigh,i,curr,r=1,w=2;

    for ( i=1; i<=n; i++ ) used[i] = 0;

    q[1]=x;
    used[x] = 1;

    while ( r < w )
    {
        curr = q[r];
        r++;

        for ( i=1; i<=a[curr][0]; i++ )
        {
            neigh = a[curr][i];

            if ( mat[curr][neigh] != 1 || used[neigh] ) continue;
            q[w] = neigh;
            w++;
            used[neigh] = 1;
        }
    }
}

int main()
{
    int x,y,m,i,j,rtx,rty,mdd;
    scanf ("%d%d",&n,&m);

    for ( i=1; i<=m; i++ )
    {
        scanf ("%d%d",&x,&y);
        mat[x][y] = mat[y][x] = 1;
        a[x][0]++;
        a[x][ a[x][0] ] = y;
        a[y][0]++;
        a[y][ a[y][0] ] = x;

        rtx = root(x);
        rty = root(y);
        if ( rtx != rty ) unite(rtx,rty);
    }

    int q,typ;
    scanf ("%d",&q);
    for ( i=1; i<=q; i++ )
    {
        scanf ("%d%d%d",&typ,&x,&y);
        if ( typ == 1 )
        {
            if ( root(x) == root(y) ) printf("1");
            else printf("0");
        }
        else if ( typ == 2 )
        {
            if ( mat[x][y] == 0 )
            {
                a[x][0]++;
                a[x][ a[x][0] ] = y;
                a[y][0]++;
                a[y][ a[y][0] ] = x;
            }
            mat[x][y] = mat[y][x] = 1;
            rtx = root(x);
            rty = root(y);
            if ( rtx != rty ) unite(rtx,rty);
        }
        else
        {

            mat[x][y] = mat[y][x] = 2;
            bfs(x);

            if ( used[y] ) continue;

            rank[x] = 0;
            for ( j=1; j<=n; j++ )
                if ( used[j] )
                {
                    par[j] = x;
                    rank[x] = 1;
                }
            par[x] = 0;

            bfs(y);

            rank[y] = 0;
            for ( j=1; j<=n; j++ )
                if ( used[j] )
                {
                    par[j] = y;
                    rank[y] = 1;
                }
            par[y] = 0;
        }
    }

    printf("\n");
}
