#include<cstdio>
#include<vector>
using namespace std;
#define MAXN 1200

int N, M, Q;
int parent[MAXN];
int uf_power[MAXN];
int path[MAXN][MAXN];
vector<int> graph[MAXN];

void ready()
{
    for(int i = 1;i <= N;i++)parent[i] = i;
}

int findParent(int pos)
{
    if(pos == parent[pos])return pos;

    parent[pos] = findParent(parent[pos]);
    return parent[pos];
}

void update(int pos1, int pos2)
{
    pos1 = findParent(pos1);
    pos2 = findParent(pos2);

    if(uf_power[pos1] == uf_power[pos2])
    {
        parent[pos1] = pos2;
        uf_power[pos2]++;
        return;
    }

    if(uf_power[pos1] < uf_power[pos2])
    {
        parent[pos1] = pos2;
        uf_power[pos2]++;
        return;
    }

    if(uf_power[pos1] > uf_power[pos2])
    {
        parent[pos2] = pos1;
        uf_power[pos1]++;
        return;
    }
}

void rebuild()
{
    for(int i = 1;i <= N;i++)
    {
        for(int j = 0;j < graph[i].size();j++)
        {
            if(path[i][ graph[i][j] ] == 2)update( i, graph[i][j]);
        }
    }
}

int main()
{
    scanf("%d%d", &N, &M);
    ready();
    int tmp1, tmp2;
    for(int i = 1;i <= M;i++)
    {
        scanf("%d%d", &tmp1, &tmp2);
        update(tmp1, tmp2);
        path[tmp1][tmp2] = 2;
        path[tmp2][tmp1] = 2;
        graph[tmp1].push_back(tmp2);
        graph[tmp2].push_back(tmp1);
    }

    scanf("%d", &Q);
    int mode;
    for(int i = 1;i <= Q;i++)
    {
        scanf("%d%d%d", &mode, &tmp1, &tmp2);
        if( mode == 1 )
        {
            if( findParent(tmp1) == findParent(tmp2) )printf("1"); else printf("0");
            continue;
        }

        if(mode == 2)
        {
            update(tmp1, tmp2);
            if(path[tmp1][tmp2] == 0)
            {
                graph[tmp1].push_back(tmp2);
                graph[tmp2].push_back(tmp1);
            }
            path[tmp1][tmp2] = 2;
            path[tmp2][tmp1] = 2;
            continue;
        }

        if(mode == 3)
        {
            path[tmp1][tmp2] = 1;
            path[tmp2][tmp1] = 1;
            ready();
            rebuild();
            continue;
        }
    }

    putchar('\n');
    return 0;
}
