
#include <iostream>
#include <iomanip>
#include <math.h>

#define ITER 1024
#define DECIMALS 2

using namespace std;

double calc(double a, double q, double p)
{
	return (2*p*q*a + (p*p - q*q)*sqrt(p*p + q*q - a*a))/(p*p + q*q);
}

double solve (int c, int a, int b)
{
	double start = sqrt(a*a - c*c);
	double end = sqrt(a*a + b*b);
	
	for (int i = 0; i < ITER; ++i) {
		if (calc((double)a, (double)c, (start + end)/2) < b)
			start = (start + end)/2;
		else
			end = (start + end)/2;
	}
	return (start + end)/2;
}

int main()
{
	int a, b, c;
	cin >> a >> b >> c;
	cout << setprecision(2) << fixed << solve(c, a, b);
	return 0;
}
