#include <iostream>
#include <string>
#include <stack>
#define MAXN 1001

bool matrix[MAXN][MAXN];
bool visited[MAXN];
int n, m;

using namespace std;

bool pathExists (int nodeA, int nodeB) {
	int i, j;

	for (i = 1; i <= n; i++) {
		visited[i] = false;
	}

	stack <int> dfs_stack;
	dfs_stack.push(nodeA);

	while (dfs_stack.size() > 0) {
		j = dfs_stack.top();
		dfs_stack.pop();

		if (!visited[j]) {
			visited[j] = true;
			
			if (matrix[j][nodeB] == true) {
				for (i = 0; i < n; i++) {
					if (visited[i]) {
						matrix[i][nodeA] = matrix[nodeA][i] = matrix[i][nodeB] = matrix[nodeB][i] = true;
					}
				}

				return true;
			}

			for (i = 1; i <= n; i++) {
				if (matrix[j][i] == true && !visited[i]) {
					dfs_stack.push(i);
				}
			}
		}

	}

	return false;
}

int main() {
	cin >> n >> m;

	int i, a, b;
	for (i = 0; i < m; i++) {
		cin >> a >> b;
		matrix[a][b] = matrix[b][a] = true;
	}

	int q, c;
	cin >> q;

	string result = "";
	for (i = 0; i < q; i++) {
		cin >> c >> a >> b;
		if (c == 1) {
			if (pathExists(a, b)) {
				result += "1";
			} else {
				result += "0";
			}
		} else if (c == 2) {
			matrix[a][b] = matrix[b][a] = true;
		}
	}

	cout << result << endl;
	return 0;
}
