#include<cstdio>
#include<iostream>
#include<cstring>
#include<vector>
#include<map>

using namespace std;

const int MAXN = 1024;

struct edge {
    int x, u;

    edge ( int x_ = 0, int u_ = 0 ) {
        x = x_;
        u = u_;
    }

};

int n, m;
bool used[MAXN];
vector < edge > v[MAXN];
int mp[MAXN][MAXN];
int tp[MAXN];

void read() {
    int i, x, y;

    scanf ( "%d %d", &n, &m );

    for ( i = 0; i < m; ++ i ) {
        scanf ( "%d %d", &x, &y );
        v[x].push_back ( edge ( y, 0 ) );
        v[y].push_back ( edge ( x, 0 ) );
        mp[x][y] = ( int ) v[x].size();
        mp[y][x] = ( int ) v[y].size();
    }

}

void dfs ( int i, int lv ) {
    int j, sz = ( int ) v[i].size();
    used[i] = 1;
    tp[i] = lv;

    for ( j = 0; j < sz; ++ j ) {
        if ( !used[ v[i][j].x ] && !v[i][j].u ) dfs ( v[i][j].x, lv );
    }

}

void solve() {
    int i, j, q, t, x, y, lv;

    lv = 1;
    for ( i = 1; i <= n; ++ i ) {
        if ( !used[i] ) {
            dfs ( i, lv );
            lv ++;
        }
    }

    scanf ( "%d", &q );

    for ( i = 0; i < q; ++ i ) {
        scanf ( "%d %d %d", &t, &x, &y );

        if ( t == 1 ) {
            if ( tp[x] == tp[y] ) printf ( "1" );
            else printf ( "0" );
        }
        else if ( t == 2 ) {
            memset ( used, 0, sizeof used );

            if ( !mp[x][y] ) {
                v[x].push_back ( edge ( y, 0 ) );
                v[y].push_back ( edge ( x, 0 ) );
                mp[x][y] = ( int ) v[x].size();
                mp[y][x] = ( int ) v[y].size();
            }
            else {
                v[x][ mp[x][y] - 1 ].u = 0;
                v[y][ mp[y][x] - 1 ].u = 0;
            }

            lv = 1;
            for ( j = 1; j <= n; ++ j ) {
                if ( !used[j] ) {
                    dfs ( j, lv );
                    lv ++;
                }
            }

        }
        else {
            memset ( used, 0, sizeof used );
            v[x][ mp[x][y] - 1 ].u = 1;
            v[y][ mp[y][x] - 1 ].u = 1;


            lv = 1;
            for ( j = 1; j <= n; ++ j ) {
                if ( !used[j] ) {
                    dfs ( j, lv );
                    lv ++;
                }
            }

        }
    }

    printf ( "\n" );

}

int main() {
    read();
    solve();

    return 0;

}
