#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
#include <cstring>

using namespace std;

struct rib {
    int x , y;
};

const int maxn = 1024 , maxm = 2048;

rib a[maxm];
int n , m;
int qu;
int par[maxn] , sz[maxn];
int to[maxn][maxn];
int vis[maxn][maxn];
int used[maxn];

queue<int> q;

vector<int> v[maxn];

void read (){
    scanf ( "%d %d" , &n , &m );
    for ( int i = 0; i < m; ++i )
        scanf ( "%d%d" , &a[i].x , &a[i].y );
    scanf ( "%d" , &qu );
}

int pos = 0;

void init (){
    for ( int i = 0 ; i <= maxn-2; ++i )
        for ( int j = 0; j <= maxn-2; ++j ) {
            to[i][j] = 0;
            to[j][i] = 0;
            vis[i][j] = 0;
            vis[j][i] = 0;
        }
    for ( int i = 1; i <= n; ++i ) {
        par[i] = i;
        sz[i] = 1;
    }
    for ( int i = 0; i < m; ++i ){
        to[a[i].x][a[i].y] = to[a[i].y][a[i].x] = 1;
        vis[a[i].x][a[i].y] = vis[a[i].y][a[i].x] = 1;
        v[a[i].x].push_back(a[i].y);
        v[a[i].y].push_back(a[i].x);
    }
    pos = m ;

}

int boss ( int ver ) {
    while ( par[ver] != ver ) {

     //    cout << ver << endl;
         ver = par[ver];
    }
    return ver;
}

void  marge ( int k1 , int k2 ) {
    int b1 = boss ( k1 ) ;
    int b2 = boss ( k2 ) ;
    if ( b1 == b2 ) {
      return;
    } else {
        if ( sz[b1] > sz[b2] ) {
            swap ( b1 , b2 ) ;
        }
        if ( sz[b1] != sz[b2] ) {
            par[b1] = b2;
        }
        else {
            par[b1] = b2;
            sz[b2] ++;
        }
    }
}

void djs (){
    for ( int i = 0; i < m; ++i ) {
        marge ( a[i].x , a[i].y );
    }
}

int br ;

void ask ( int y1 , int y2 ) {
    ++br;
    int b1 = boss ( y1 );
    int b2 = boss ( y2 ) ;
   // cout << "YES " << b1 << ' '<< b2 << endl;
    if ( b1 == b2 ) printf ( "1" );
    else printf ( "0" );
}

void add ( int y1 , int y2 ) {
    marge ( y1 , y2 );
    if ( vis[y1][y2] == 0 ) {
        v[y1].push_back(y2);
        v[y2].push_back(y1);
        vis[y1][y2] = vis[y2][y1] =  1;
    }
    to[y1][y2] = to[y2][y1] = 1;
    ++pos;
}



void bfs ( int ver ) {
    par[ver] = ver;
    sz[ver] = 2;
    int tmp;
    used[ver] = 1;
    while ( !q.empty() ) q.pop();
    q.push(ver);
    while ( !q.empty() ) {
        tmp = q.front();
        q.pop();
        for ( int i = 0; i < v[tmp].size(); ++i )
            if ( to[tmp][v[tmp][i]] && used[v[tmp][i]] == 0){
                used[v[tmp][i]] = 1;
                q.push(v[tmp][i]);
                par[v[tmp][i]] = ver;
            }
    }
}

void remove ( int y1 , int y2 ) {
   memset ( used , 0 , sizeof ( used ) ) ;
   to[y1][y2] = to[y2][y1] = 0;
   bfs ( y1 );
   if ( used[y2] == 0 ) bfs ( y2 );
}

void solve (){
    init ();
    djs();
    int d , b , c;
    for ( int i = 0; i < qu; ++i ) {
        scanf ( "%d%d%d" , &d , &b , &c );
        if ( d == 1 ) ask ( b , c ) ;
        if ( d == 2 ) add  ( b , c) ;
        if ( d == 3 ) remove ( b , c);
    }
    printf ( "\n" );
   // cout << br << endl;
}

int main (){
    read ();
    solve ();
    return 0;
}
