#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;

struct point{
    double x, y;

    point(){}
    point ( double _x, double _y ){
        x = _x;
        y = _y;
    }
};
int a, b, c;

void scan(){
    scanf ( "%d%d%d", &a, &b, &c );
}

inline double dist ( point t1, point t2 ){
    return  sqrt( ( t1.x - t2.x ) * ( t1.x - t2.x ) +
                  ( t1.y - t2.y ) * ( t1.y - t2.y ) );
}

inline point intersect ( point p1, point p2, point q1, point q2 ){
    double A1 = ( p1.y - p2.y ), B1 = ( p2.x - p1.x ), C1 = p1.x * p2.y - p2.x * p1.y;
    double A2 = ( q1.y - q2.y ), B2 = ( q2.x - q1.x ), C2 = q1.x * q2.y - q2.x * q1.y;

    int swp = 0;
    if ( B1 == 0 ){
        swap ( A1, B1 );
        swap ( A2, B2 );
        swp = 1;
    }
    double x = ( C1 * B2/B1 - C2 ) / ( A2 - A1 * B2 / B1 );
    double y = ( -A1 * x - C1 ) / B1;

    if ( swp ){
        swap ( A1, B1 );
        swap ( A2, B2 );
        swap ( x, y );
    }

    return point ( x, y );
}


double go ( double x ){
    point p(x, 0), q( 0, sqrt ( c * c - x * x ) );
    point p1, q1;

    p1 = point ( - ( q.y - p.y ) + p.x , ( q.x - p.x ) + p.y );
    q1 = point ( - ( p.y - q.y ) + q.x , ( p.x - q.x ) + q.y );

    point D( 0, b ), C( a, b ), B( a, 0 );

    point q2 = intersect ( D, C, q, q1 ), q3 = intersect ( B, C, q, q1 );
    point p2 = intersect ( D, C, p, p1 ), p3 = intersect ( B, C, p, p1 );

    return min ( min ( dist ( q, q2 ), dist ( q, q3 ) ), min ( dist ( p, p2 ), dist ( p, p3 ) ) );
}

void solve(){
    double l = 0, r = c;


    for ( int i = 0; i < 1000; ++i ){
        double l1 = ( l + l + r ) / 3., r1 = ( r + r + l ) / 3.;

        if ( go ( l1 ) > go ( r1 ) ) r = r1;
        else l = l1;
    }

    double mx = a;
    if ( mx < go ( ( l + r ) / 2. ) )
        mx = go ( ( l + r ) / 2. );

    printf ( "%.2f\n", mx   );

}

int main(){
    scan();
    solve();
}
