#include <cstdio>
#include <vector>
#include <queue>
using namespace std;

bool used[1 << 10];
int comp[1 << 10];
vector<int> neig[1 << 10];

void removeEdge(int a, int b) {
    unsigned size = neig[a].size();
    int swap;
    vector<int>::iterator it = neig[a].begin();
    for (unsigned i = 0;i < size; ++i, it++) {
        if (neig[a][i] == b) {
            //swap = neig[a][i];
            //neig[a][i] = neig[a][size - 1];
            //neig[a][size - 1] = swap;
            break;
        }
    }
    neig[a].erase(it);
}

int query(int a) {
    while (comp[a] != a) {
        a = comp[a];
    }
    return a;
}

queue<int> que;
void bfs(int start) {
    used[start] = 1;
    comp[start] = start;
    que.push(start);
    int top;
    while (!que.empty()) {
        top = que.front(); que.pop();
        for (unsigned i = 0; i < neig[top].size(); ++i) {
            if (!used[neig[top][i]]) {
                used[neig[top][i]] = 1;
                comp[neig[top][i]] = start;
                que.push(neig[top][i]);
            }
        }
    }
}

void recalc(int n) {
    for (int i = 0; i < n; ++i) {
        used[i] = 0;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            bfs(i);
        }
    }
}

int main() {
    int n, m;
    scanf("%d %d", &n, &m);
    int a, b;
    for (int i = 0;i < m; ++i) {
        scanf("%d %d", &a, &b);
        neig[a].push_back(b);
        neig[b].push_back(a);
    }
    recalc(n);
    int q;
    scanf("%d", &q);
    int code;
    for (int i = 0; i < q; ++i) {
        scanf("%d %d %d", &code, &a, &b);
        if (code == 1) {
            printf("%d", query(a) == query(b));
        } else if (code == 2) {
            neig[a].push_back(b);
            neig[b].push_back(a);
            comp[query(a)] = comp[query(b)];
        } else if (code == 3) {
            removeEdge(a, b);
            removeEdge(b, a);
            recalc(n);
        }
    }
    puts("");
    return 0;
}
