#include <iostream>
#include <ctime>
size_t component[1<<10];
bool inGraph[1<<10][1<<10];
bool hanging[1<<10][1<<10]; // Not in the actual graph. inGraph==false but in graph. Needs to be erased on relabel.
size_t haveHanging;
size_t graph[1<<10][1<<10];
size_t edges[1<<10];
size_t n;
void relabel(size_t v, size_t to){
    component[v]=to;
    for(size_t i=0;i<edges[v];i++){
        if(!inGraph[v][graph[v][i]]){
            hanging[v][graph[v][i]]=false;
            graph[v][i]=graph[v][--edges[v]];
            i--;
        }else{
            if(component[graph[v][i]]==1<<10) relabel(graph[v][i], to);
        }
    }
    return;
}
void relabelAll(){
    haveHanging=0;
    for(size_t i=0;i<n;i++) component[i]=1<<10;
    for(size_t i=0;i<n;i++) if(component[i]==1<<10) relabel(i, i);
    return;
}
size_t find(size_t n){
    return component[n]==n? n : component[n]=find(component[n]);
}
void union_(size_t a, size_t b){
    component[find(b)]=find(a);
    return;
}
void eraseEdge(size_t from, size_t to){
    if(!inGraph[from][to]) return;
    hanging[from][to]=true;
    hanging[to][from]=true;
    inGraph[from][to]=false;
    inGraph[to][from]=false;
    haveHanging++;
    return;
}
void addEdge(size_t from, size_t to){
    if(hanging[from][to]){
        hanging[from][to]=false;
        hanging[to][from]=false;
        inGraph[from][to]=true;
        inGraph[to][from]=true;
        haveHanging--;
        return;
    }
    if(inGraph[from][to]) return;
    inGraph[from][to]=true;
    inGraph[to][from]=true;
    graph[from][edges[from]++]=to;
    graph[to][edges[to]++]=from;
    union_(from, to);
    return;
}
bool connected(size_t a, size_t b){
    if(haveHanging) relabelAll();
    return find(a)==find(b);
}
char out[1<<17];
size_t outSize;
int main(){
    size_t m, q;
    std::ios::sync_with_stdio(false);
    std::cin.tie(NULL);
    std::cin>>n>>m;
    for(size_t i=0;i<n;i++) component[i]=i;
    for(size_t i=0;i<m;i++){
        size_t a, b;
        std::cin>>a>>b;
        a--;
        b--;
        addEdge(a, b);
    }
    std::cin>>q;
    for(size_t i=0;i<q;i++){
        size_t k, a, b;
        std::cin>>k>>a>>b;
        a--;
        b--;
        if(k==1) out[outSize++]=connected(a, b)?'1':'0';
        else if(k==2) addEdge(a, b);
        else eraseEdge(a, b);
    }
    out[outSize++]='\n';
    std::cout<<out;
    return 0;
}
