/*
	Author: Boris Yonchev 
	School: TUES
*/
#include <iostream>
#include <cmath>
using namespace std;

unsigned short n;
unsigned long long p;

unsigned long long ten_powers[] = {1, 10, 100, 1000, 10000, 100000, 1000000, 10000000, 100000000, 1000000000, 10000000000, 100000000000, 1000000000000, 10000000000000, 100000000000000};

void read_input()
{
    cin >> n >> p;
}

bool is_palindrome(unsigned long long current)
{   
    for (int i = 0; i < n / 2; i++)
    {        
        unsigned long long a = (current / ten_powers[n-i-1]) % 10;
        unsigned long long b = (current % ten_powers[i+1]) / ten_powers[i];
    
        if (a != b)
        {
            return false;
        }        
    }
    
    return true;
}

int main()
{    
    read_input();
    
    unsigned long long current = ten_powers[n-1], max = current * 10, step = 1;
    
    int result = 0;
    
    bool found_first = false;
    
    while(current < max)
    {
        if ((step == 1) && (current % p == 0))
        {
            step = p;            
            found_first = true;
        }
        
        if (found_first)
        {
            if (is_palindrome(current))
            {
                result++;
            }                
        }
        
        current += step;
    }
    
    /* 0 fix */
    if (n == 1)
        result++;
        
    cout << result;
        
    return 0;
}
