/* Dimitar Vlahovski 12b klas TUES */
#include<iostream>
#include<vector>
using namespace std;


int N, M, Q;



class Node
{
public:
    int id;
    vector<int> neighbours;

    Node()
    {

    }

    Node(int a, int b)
    {
        id = a;
        neighbours.push_back(b);
    }

    vector<int>::iterator get_neighbour(Node n)
    {
        for(vector<int>::iterator it = neighbours.begin(); it != neighbours.end(); ++it)
        {
            if(*it == n.id)
                return it;
        }

        return neighbours.end() + 1;
    }

};

vector<Node> nodes;


vector<Node>::iterator get_node(Node n)
{
    for(vector<Node>::iterator it = nodes.begin(); it != nodes.end(); ++it)
    {
        if(it->id == n.id)
            return it;
    }

    return nodes.end() + 1;
}


bool route_exists(int t1, int t2, Node from)
{
    Node n1 = Node(t1,t2);
    vector<Node>::iterator it1 = get_node(n1);
    Node n2 = Node(t2, t1);
    vector<Node>::iterator it2 = get_node(n2);

    if(it1->get_neighbour(n2) != it1->neighbours.end() + 1)
    {
        return true;
    }
    else
    {
        for(vector<int>::iterator it = it2->neighbours.begin(); it != it2->neighbours.end(); ++it)
        {
            if(*it != from.id)
            {
                if(route_exists(t1, *it, n1) == true)
                    return true;
            }
        }
        return false;
    }

}


int main()
{
    cin >> N >> M;
    int a,b;
    Node n1, n2;
    for(int i = 0; i < M; i++)
    {
        cin >> a >> b;
        n1 = Node(a,b);
        n2 = Node(b,a);
        vector<Node>::iterator it1 = get_node(n1);
        vector<Node>::iterator it2 = get_node(n2);
        if(it1 != nodes.end() + 1)
        {
            it1->neighbours.push_back(b);
        }
        else
        {
            nodes.push_back(n1);
        }

        if(it2 != nodes.end() + 1)
        {
            it2->neighbours.push_back(a);
        }
        else
        {
            nodes.push_back(n2);
        }
    }

    cin >> Q;
    int call_type, t1, t2;
    vector<Node>::iterator it_aa;
    vector<Node>::iterator it_bb;

    for(int i=0; i < Q; i++)
    {
        cin >> call_type >> t1 >> t2;

        switch(call_type)
        {
            case 1:
                if(route_exists(t1, t2, Node(0,0)))
                {
                    cout << "1";
                }
                else
                {
                    cout << "0";
                }
                break;

            case 2:
                it_aa = get_node(Node(t1,t2));
                it_aa->neighbours.push_back(t2);
                it_bb = get_node(Node(t2,t1));
                it_bb->neighbours.push_back(t1);
                break;

            case 3:
                it_aa = get_node(Node(t1,t2));
                it_bb = get_node(Node(t2,t1));


                break;
            default:
                cout << "unknown call type";
                return -1;
        }

    }


    return 0;
}
