/*
 *  NOI 2013
 *  ROUND 2
 *  
 *  TASK 1
 *  NO112A
 *
 *  Author: Valentin Kirilov Kirilov
 *  School: Techological School of Electronics Systems at the TU - Sofia
 *  Email:  val.kirilov@gmail.com
 */
 
#include <iostream>
#include <vector>
using namespace std;

vector<int> currentPath;

class struct_city {
    int cityId;
    vector<struct_city> connections;

public:
    struct_city() {
        cityId = 0;
    }
    struct_city(int id) {
        cityId = id;
    }

    int getCityId() {
        return cityId;
    }
    void setConnection(struct_city value) {
        connections.push_back(value);
    }
    struct_city getConnection(int index) {
        return connections.at(index);
    }
    void printId() {
        cout << cityId;
    }
    void print() {
        cout << "CITY: ";
        printId();
        cout << ": CONNECTIONS WITH: ";
        
        if (connections.size() > 0) {
            connections.at(0).printId();
        }
        if (connections.size() > 1) {
            cout << ", ";
            connections.at(1).printId();
        }
        cout << endl;
    }
    
    bool findPath(struct_city city1, struct_city city2) {
        //cout << " >> START PATH FINDING FROM " << city1.getCityId() << " TO " << city2.getCityId() << endl; 
        
        // End of recursion
        if (city1.getCityId() == city2.getCityId()) {
            //cout << endl << " --------------------- WE FOUND IT" << endl;
            return true;
        }
        
        // If we were here
        int weWereHereCounter = 0;
        bool validLoop = true;
        while (validLoop == true) {
            try {
                if (currentPath.at(weWereHereCounter) == city1.getCityId()) {
                    //cout << "<< WE WERE HERE" << endl;
                    return false;
                }
            }
            catch (exception exeption) {
                validLoop = false;
            }
            weWereHereCounter++;
        }
        
        // Save that we were here
        currentPath.push_back(city1.getCityId());
        
        // Make recursion here
        int recursionConnectionsCounter = 0;
        bool validLoopRecursion = true;
        bool innerRecursion = false;
        while (validLoopRecursion == true) {
            try {
                //cout << "GOING ON FROM " << connections.at(recursionConnectionsCounter).getCityId() << " TO " << city2.getCityId() << endl;
                if (innerRecursion == true) {
                    //cout << "RETURN BECAUSE OF INNER RECURSION" << endl;
                    validLoopRecursion = false;
                }
                if (city2.getCityId() == connections.at(recursionConnectionsCounter).getCityId()) {
                    //cout << "HMM FOUND!!!" << endl;
                }
                
                innerRecursion = connections.at(recursionConnectionsCounter).findPath(connections.at(recursionConnectionsCounter), city2);
            }
            catch (exception exeption) {
                validLoopRecursion = false;
            }
            recursionConnectionsCounter++;
        }
        
        //cout << "END OF EVERYTHING FROM CITY " << cityId << " " << innerRecursion << endl;
        return innerRecursion;
    }
};


class class_call {
private:
    int callType;
    int city1;
    int city2;
    
public:
    class_call(int cT, int c1, int c2) {
        callType = cT;
        city1 = c1;
        city2 = c2;
    }
    
    int getCallType() {
        return callType;
    }
    int getCity(int index) {
        if (index == 1) {
            return city1;
        }
        else if (index == 2) {
            return city2;
        }
        return 0;
    }
    void print() {
        cout << "CALL: " << callType << "; CITIES: " << city1 << ", " << city2 << endl;
    }
    bool isExist() {
        return true;
    }
};

class class_connection {
private:
    bool connectionStatus;
    struct_city city1;
    struct_city city2;
    
public:
    class_connection(bool cS, struct_city c1, struct_city c2) {
        connectionStatus = cS;
        city1 = c1;
        city2 = c2;
    }
    
    bool isExist() {
        return true;
    }
    void setConnectionStatus(bool newStatus) {
        connectionStatus = newStatus;
    }
    bool getConnectionStatus() {
        return connectionStatus;
    }
    struct_city getCity1() {
        return city1;
    }
    struct_city getCity2() {
        return city2;
    }
    void print() {
        //cout << "STATUS: " << connectionStatus << "; CITIES: " << city1 << " -> " << city2 << endl;
    }
};

// Global variables
int N = 0;
int M = 0;
int CALLS = 0;
vector<struct_city> cities;
vector<class_call> callsRecords;
vector<class_connection> availableConnections;
vector<int> callsAnswers;

/*
void printCities() {
    cout << ">>PRINT CITIES;" << endl; 
    cout << cities.size() << endl;
     
    int counter = 0;
    bool validLoop = true;
    while (validLoop == true) {
        try {
            cities.at(counter).print();
        }
        catch (exception exeption) {
            validLoop = false;
            break;
        }
        
        counter++;
    }
    cout << endl;
}
*/

void printCalls() {
    cout << ">>PRINT CALLS RECORDS;" << endl; 
    cout << callsRecords.size() << endl;
     
    int counter = 0;
    bool validLoop = true;
    while (validLoop == true) {
        try {
            callsRecords.at(counter).print();
        }
        catch (exception exeption) {
            validLoop = false;
            break;
        }
        
        counter++;
    }
    cout << endl;
}
void printAvailableConnections() {
    cout << ">>PRINT AVAILABLE CONNECTIONS;" << endl; 
    cout << availableConnections.size() << endl;
     
    int counter = 0;
    bool validLoop = true;
    while (validLoop == true) {
        try {
            availableConnections.at(counter).print();
        }
        catch (exception exeption) {
            validLoop = false;
            break;
        }
        
        counter++;
    }
    cout << endl;
}
/*void printCity(struct_city city) {
    city.print();
}*/

void readInput() {
    cin >> N >> M;

    // Init cities
    for (int nCounter=0; nCounter < N; nCounter++) {
        struct_city newCity(nCounter+1);
        cities.push_back(newCity);
    }
    //printCities();
    
    // Read cities
    for (int mCounter=0; mCounter < M; mCounter++) {
        int connection1, connection2 = 0;
        cin >> connection1 >> connection2;
        
        //cout << "READ: "<< connection1 << " " << connection2 << endl;
        
        cities.at(connection1-1).setConnection(cities.at(connection2-1));
        cities.at(connection2-1).setConnection(cities.at(connection1-1));
        
        class_connection newConnection(true, cities.at(connection1-1), cities.at(connection2-1));
        availableConnections.push_back(newConnection);
    }
    //printCities();
    
    cin >> CALLS;
    
    // Read calls
    for (int callsCounter=0; callsCounter < CALLS; callsCounter++) {
        int callType = 0;
        int callCity1 = 0;
        int callCity2 = 0;
        
        cin >> callType >> callCity1 >> callCity2;
        //cout << "CALL: " << callType << " " << callCity1 << " " << callCity2 << endl;
        
        class_call newCall(callType, callCity1, callCity2);
        callsRecords.push_back(newCall);
    }
    //printCalls();
    
    return;
}

bool checkConnectionStatus(int city1, int city2) {
    bool connectionFound = false;
    bool moreConnections = true;
    int connectionsCounter = 0;
    
    while (moreConnections == true) {
        try {
            availableConnections.at(connectionsCounter).isExist();
            bool finalStatus = availableConnections.at(connectionsCounter).getCity1().findPath(cities.at(city1-1), cities.at(city2-1));
                                                                            
            //cout << "PATH STATUS: " << finalStatus << endl;
            currentPath.clear();
            
            /*
            if (availableConnections.at(connectionsCounter).getCity1().getCityId() == city1 &&
                availableConnections.at(connectionsCounter).getCity2().getCityId() == city2) {
                    connectionFound = true;
                    cout << ">>Connection found in " << city1 << " and " << city2 << endl;
                    return connectionFound;
                }
                */
        }
        catch (exception exeption) {
            moreConnections = false;
            break;
        }
        
        connectionsCounter++;
        return connectionFound;
    }
}
void humanCall(int callIndex) {
    // Check is available
    
    int city1 = callsRecords.at(callIndex).getCity(1);
    int city2 = callsRecords.at(callIndex).getCity(2);
    
    //cout << "Human is calling to ask for " << city1 << " and " << city2 << endl;
    bool connectionStatus = checkConnectionStatus(city1, city2);
    //cout << connectionStatus << endl;
}

void solveTask() {
    int callCounter = 0;
    bool callsStillExist = true;
    
    while (callsStillExist == true) {
        try {
            callsRecords.at(callCounter).isExist();
            
            // Current call
            callsRecords.at(callCounter);
            
            if (callsRecords.at(callCounter).getCallType() == 1) {
                humanCall(callCounter);
            }
            else if (callsRecords.at(callCounter).getCallType() == 2) {
                // Clear call
            }
            else if (callsRecords.at(callCounter).getCallType() == 3) {
                // Problem call
            }
        }
        catch (exception exeption) {
            callsStillExist = false;
            break;
        }
        
        callCounter++;
    }
}


int main() {
    
    readInput();
    
    // Input data check
    //printCities();
    //printCalls();
    //printAvailableConnections();
    
    solveTask();
    cout << "112 NUMBER IS DOWN :(" << endl;
    
    return 0;
}