/*
 *  NOI 2013
 *  ROUND 2
 *  
 *  TASK 3
 *  PALI
 *
 *  Author: Valentin Kirilov Kirilov
 *  School: Techological School of Electronics Systems at the TU - Sofia
 *  Email:  val.kirilov@gmail.com
 */

#include <iostream>
#include <string>
#include <fstream>
#include <cmath>
#include <vector>
using namespace std;

int N;
int P;
vector<unsigned long long> RESULT;

void readInput() {
    cin >> N >> P;
    //cout << N << " " << P;
}
string toString(unsigned long long pattern) {
    string newString;
    while (pattern / 10 > 0) {
        int lastNumber = pattern % 10;
        switch (lastNumber) {
            case 0: newString.append("0"); break;
            case 1: newString.append("1"); break;
            case 2: newString.append("2"); break;
            case 3: newString.append("3"); break;
            case 4: newString.append("4"); break;
            case 5: newString.append("5"); break;
            case 6: newString.append("6"); break;
            case 7: newString.append("7"); break;
            case 8: newString.append("8"); break;
            case 9: newString.append("9"); break;
        }
        //cout << lastNumber << " " << newString << endl;;
        pattern /= 10;
    }
    switch (pattern) {
            case 0: newString.append("0"); break;
            case 1: newString.append("1"); break;
            case 2: newString.append("2"); break;
            case 3: newString.append("3"); break;
            case 4: newString.append("4"); break;
            case 5: newString.append("5"); break;
            case 6: newString.append("6"); break;
            case 7: newString.append("7"); break;
            case 8: newString.append("8"); break;
            case 9: newString.append("9"); break;
        }
    return newString;
}

bool isPalindrom(unsigned long long pattern) {
    string strPattern = toString(pattern);
    //cout << "STRNG: " << strPattern << "; ";
    
    //if (strPattern == "0")
    //    return true;
    
    int length = strPattern.length();
    int frontCounter = 0;
    int backCounter = length -1;
    
    for (frontCounter = 0; frontCounter < (length /2 + 1); frontCounter++) {
        //cout << strPattern[frontCounter] << " " << strPattern[backCounter] << " " << (strPattern[frontCounter] == strPattern[backCounter]);
        if (strPattern[frontCounter] != strPattern[backCounter]) {
            //cout << " FALSE" << endl;
            return false;
        }
        backCounter--;
    }
    
    return true;
}

void solveTask() {
    // Generate palindroms
    N -= 1;
    //cout << "generating.. 10^" << N << " FROM: " << (1* pow(10,N)) << "; TO: " << 1 * pow(10,N+1) << endl;
    
    // Try to optimize generating only with palindrom not all numbers, because now is slow
    // Nope, I'm lazy and bored now
    
    unsigned long long generated = 0;
    for (generated = 1 * pow(10,N); generated < 1 * pow(10,N+1); generated++) {
        //cout << generated << " ";
        bool palindrom = isPalindrom(generated);
        if (palindrom == true) {
            if (generated % P == 0) {
                //cout << generated << " ";
                
                // Chek is the result exist
                int counter = 0;
                bool validLoop = true;
                while (validLoop == true) {
                    try {
                        if (RESULT.at(counter) == generated) {
                            validLoop = false;
                        }
                    }
                    catch (exception exeption) {

                        RESULT.push_back(generated);
                        validLoop = false;
                    }
                    
                    counter++;
                }
            }
        }
    }
}

int main() {

    readInput();
    solveTask();
    
    cout << RESULT.size();
    return 0;
}