# include <iostream>
# include <deque>

using namespace std;

bool region [1000][1000];
short villages, roads;
deque <bool> checked;
deque <bool> answers;
deque <short> component [1000];

void uncheck () {

    for ( short i = 0 ; i < villages ; i ++ )
    checked [i] = 0;

}

void init () {

    for ( short i = 0 ; i < villages ; i ++ ) {

         region [i][i] = 1;
         checked.push_back (0);

    }

}

void get_components () {

    short next_component = 0;

    for ( short k = 0 ; k < villages ; k ++ )
    if ( !checked [k] ) {

         deque <short> c;
         c.push_back (k);

         component [next_component].push_back (k);

         checked [k] = 1;

         while ( !c.empty () ) {

              short i = c.front ();

              for ( short j = 0 ; j < villages ; j ++ )
              if (  checked [j] == 0 && region [i][j] ) {

                   component [next_component].push_back (j);
                   c.push_back (j);

                   checked [j] = 1;

              }

              checked [i] = 1;
              c.pop_front ();

         }

         next_component ++;

    }

    uncheck ();
}

void clear_components () {

    for ( short i = 0 ; i < villages ; i ++ )
    while ( !component [i].empty () )
    component [i].pop_back ();

}

void input_before_qs () {

    cin >> villages >> roads;

    init ();

    for ( short i = 0 ; i < roads ; i ++ ) {

         short x, y;

         cin >> x >> y;
         x --;
         y --;

         region [x][y] = 1;
         region [y][x] = 1;

    }

    get_components ();

}

void output () {

    while ( !answers.empty () ) {

         cout << answers.front ();
         answers.pop_front ();

    }

    cout << endl;

}

bool possible_travel ( short &x, short &y ) {

    bool x_is_here;
    bool y_is_here;

    for ( short k = 0 ; k < villages ; k ++ ) {

         x_is_here = 0;
         y_is_here = 0;

         if ( !component [k].empty () ) {

              for ( short i = 0 ; i < villages ; i ++ )
              if ( component [k][i] == x ) {

                   x_is_here = 1;
                   break;

              }

              if ( x_is_here )
              for ( short i = 0 ; i < villages ; i ++ )
              if ( component [k][i] == y ) {

                   y_is_here = 1;
                   break;

              }

              if ( x_is_here && y_is_here )
              return 1;

         }

         else break;

    }

    return 0;

}

int main () {

    input_before_qs ();

    int q;

    for ( cin >> q ; q > 0 ; q -- ) {

         short t, x, y;

         cin >> t >> x >> y;
         x --;
         y --;

         if ( t == 1 ) {

              bool ans = possible_travel ( x, y );
              answers.push_back (ans);

         }

         else {

              region [x][y] = 1;
              region [y][x] = 1;

              clear_components ();
              get_components ();

         }

    }

    output ();

    return 0;

}
