#include <iostream>
#include <cstdio>
using namespace std;
#define MAXN 1005

int n, m;

int pages[MAXN];
double price[MAXN];

void read() {
    scanf("%d %d", &n, &m);
    //cin >> n >> m;
    for(int i = 0; i < n; i++) {
        scanf("%d %lf", &(pages[i]), &(price[i]));
        //cin >> pages[i] >> price[i];
    }  
}

double d[MAXN][MAXN];

double solve() {
    for(int i = 0; i < n; i++) {
        d[i][0] = 0;
    }
    
    for(int j = 1; j <= m; j++) {
        for(int i = 0; i < n; i++) {
            if(pages[i] > j) {
                d[i][j] = -1;
            } else {
                d[i][j] = price[i];
                for(int k = 0; k < i; k++) {
                    if(d[i][j] < price[i] + d[k][j-pages[i]]) {
                        d[i][j] = price[i] + d[k][j-pages[i]];
                    }
                }
            }
        }
    }
    
    double max = -1.0;
    for(int i = 0; i < n; i++) {
        if(max < d[i][m]) {
            max = d[i][m];
        }
    }
    
    return max;
}

double getD(int i, int j) {
    if(j <= 0) {
        return 0;
    } else if(d[i][j] != 0) {
        return d[i][j];
    } else {
        if(pages[i] > j) {
            d[i][j] = -1;
        } else {
            d[i][j] = price[i];
            for(int k = 0; k < i; k++) {
                if(d[i][j] < price[i] + getD(k, j-pages[i])) {
                    d[i][j] = price[i] + getD(k, j-pages[i]);
                }
            }
        }
        return d[i][j]; 
    }
}

double solveWithRecursion() {
    double max = -1.0;
    for(int i = 0; i < n; i++) {
        if(max < getD(i, m)) {
            max = getD(i, m);
        }
    }
    
    return max;
}

void printd() {
    for(int j = 1; j <= m; j++) {
        for(int i = 0; i < n; i++) {
            cout << d[i][j] << " ";
        }
        cout << endl;
    }
}

int main() {
    read();
    double result = solve();
    //printd();
    
    printf("%.2f\n", result);
    
    return 0;
}