#include <iostream>
#include <cstdlib>
#include <cstdio>
using namespace std;

#define MAXN 1005

int n, m;

int par[MAXN];
int size[MAXN];
    
int root(int el) {
    int root = el;
    while(par[root]!=root) {
        par[root] = par[par[root]];
        root = par[root];
    }
    return root;
}

void unite(int a, int b) {
    int roota = root(a);
    int rootb = root(b);
    if(size[roota] < size[rootb]) {
        par[root(a)] = root(b);
        size[rootb] += size[roota];
    } else {
        par[root(b)] = root(a);
        size[roota] += size[rootb];
    }
    
    //par[root(a)] = root(b);
    #ifdef DEBUG
    cout << "united " << a << " " << b << endl;
    #endif
}

bool find(int a, int b) {
    //cout << "search for " << a << " " << b << endl;
    return root(a) == root(b);
}

void printCurrState() {
    for(int i = 0; i <= n; i++) {
        cout << i << "\t";
    }
    cout << endl;
    
    for(int i = 0; i <= n; i++) {
        cout << par[i] << "\t";
    }
    cout << endl;
     for(int i = 0; i <= n; i++) {
        cout << root(i) << "\t";
    }
    cout << endl;
}

void testUF() {
        
    exit(0);
}

void init() {
    for(int i = 0; i <= n; i++) {
        par[i] = i;
        size[i] = 1;
    }
}

int main() {
    
    // SOLVE
    int m;
    scanf("%d %d", &n, &m);
    //cin >> n >> m;
    init();
    
    int a, b;
    for(int i = 0; i < m; i++) {
        scanf("%d %d", &a, &b);
        //cin >> a >> b;
        unite(a, b);
        #ifdef DEBUG
        printCurrState();
        #endif
    }
    
    
    int q;
    scanf("%d", &q);
    //cin >> q;
    int type, city1, city2;
    for(int i = 0; i < q; i++) {
        scanf("%d %d %d", &type, &city1, &city2);
        //cin >> type >> city1 >> city2;
        if(type == 1) {
            printf("%d", find(city1, city2));
        } else { // type == 2
            unite(city1, city2);
        }
    }
    printf("\n");
    
    return 0;
}