#include <iostream>
#include <cstdlib>
using namespace std;

#define MAXN 500

int nod(int a, int b) {
    if(b>a) {
        swap(a, b);
    }
    int c;
    
    while(b > 0) {
        c = a%b;
        a = b;
        b = c;
    }
    
    return a;
}

int nodExecutions(int a, int b) {
    if(b>a) {
        swap(a, b);
    }
    int c;
    int executions = 0;
    while(b > 0) {
        c = a%b;
        executions ++;
        a = b;
        b = c;
    }
    
    return executions;
}

int n;

void read() {
    cin >> n;
}

void printStats(int maxI, int maxJ) {
    for(int j = 1; j < maxJ; j++) {
        cout << j << "\t";
    }
    cout << endl;
    
    for(int i = 1; i < maxI; i++) {
        for(int j = 1; j < maxJ; j++) {
            int nodv = nod(i, j);
            cout << nodExecutions(i, j) << " " << i/nodv << "\t";
        }
        cout << endl;
    }
}

void nodTest() {
    int i, j;
    cin >> i >> j;
    cout << nod(i, j) << endl;
    exit(0);
}

#define MAX_DIG 150
struct BigInt {
    char dig[MAX_DIG];
    int len;
    
    void print() {
        for(int i = len-1; i >= 0; i--) {
            cout << (char)('0' + dig[i]);
        }
    }
};

BigInt sum(BigInt a, BigInt b) {
    int naum = 0;
    int ad, bd;
    BigInt res;
    for(int i = 0; ;i++) {
        if(i >= a.len && i >= b.len && naum == 0) {
            res.len = i;
            break;
        }
        
        if(i < a.len) {
            ad = a.dig[i];
        } else {
            ad = 0;
        }
        
        if(i < b.len) {
            bd = b.dig[i];
        } else {
            bd = 0;
        }
        
        res.dig[i] = (ad + bd + naum)%10;
        naum = (ad + bd + naum) / 10;
        
       // cout << ad << " " << bd << " " << '0' + res.dig[i] << " " <<  << " " << naum << endl;
    }
    
    return res;
}

void printFib() {
    long long a = 1;
    long long b = 1;
    long long c;
    for(int i = 3; i <= 100; i++) {
        c = a+b;
        cout << i << " " << c << endl;
        a = b;
        b = c;
    }
}

void printFibBigInt() {
    BigInt a;
    BigInt b;
    BigInt c;
    a.dig[0] = 1;
    a.len = 1;
    b.dig[0] = 1;
    b.len = 1;
    for(int i = 3; i <= 500; i++) {
        c = sum(a,b);
        //cout << i << " "; 
       // c.print();
        //cout << " " << c.len << endl;
        a = b;
        b = c;
    }
}

void testBigInt() {
    BigInt a;
    BigInt b;
    BigInt c;
    a.dig[0] = 1;
    a.len = 1;
    b.dig[0] = 1;
    b.len = 1;
    c = sum(a,b);
    c.print();
    cout << endl;
    exit(0);
}


int main() {
    //testBigInt();
    //printFibBigInt();
    //return 0;
    //cout << no dExecutions(9, 12) << endl;
    //printStats(20, 10);
    
    read();
    
    BigInt a;
    BigInt b;
    BigInt c;
    a.dig[0] = 1;
    a.len = 1;
    b.dig[0] = 1;
    b.len = 1;
    for(int i = 3; i <= n+2; i++) {
        c = sum(a,b);
        //cout << i << " "; 
        //c.print();
        //cout << " " << c.len << endl;
        a = b;
        b = c;
    }
    
    a.print();
    cout << " ";
    c.print();
    cout << endl;
    
    return 0;
}