#include <cstdio>

/*

9 8

1 2
3 4
5 6
7 8
9 5
7 2
8 2
6 9

6
1 1 8
1 6 2
2 7 1
1 4 7
2 2 3
1 4 7

*/

#define MAXN 1000
#define MAXQ 1000000

int N,Q,sol_n=0;
bool gmap[MAXN+1][MAXN+1];

int groups[MAXN+1], q[MAXN+1];
bool u[MAXN+1];

void build_group(int idx, int group)
{
	int qn=1,qn_old=0,beg;
	q[0] = idx;
	while(qn > qn_old)
	{
		beg = qn_old;
		qn_old = qn;
		//printf("%d %d\n", idx, group);
		//printf("%d %d\n", beg, qn_old);
		for(int i=beg; i<qn_old; i++)
		{
			groups[q[i]] = group;
			u[q[i]] = true;
			for(int j=1; j<=N; j++) if(!u[j] && gmap[q[i]][j]) { q[qn]=j; qn++; }
		}
	}
}

void init()
{
	//BFS in order to build groups[]
	//O(N^2)
	
	for(int i=1; i<=N; i++) u[i]=false;
	int group=0;
	for(int i=1; i<=N; i++) if(!u[i]) { build_group(i,group); group++; }
}

//------------------

// set groups[i] to g1 for each i where groups[i]==g2
void combine( int g1, int g2 ) { for(int i=0; i<N; i++) if(groups[i] == g2) groups[i]=g1; }

void solve()
{
	//O(Q + N^2)
	int cmd,a,b;
	for(int i=0; i<Q; i++)
	{
		scanf("%d %d %d", &cmd, &a, &b);
		if(cmd == 1) printf("%d", (groups[a] == groups[b]));
		else if(groups[a] != groups[b]) combine(groups[a], groups[b]);
	}
}

int main()
{
	//freopen("no112b.in", "r", stdin);
	int M,a,b;
	
	scanf("%d %d", &N, &M);
	for(int i=0; i<M; i++)
	{
		scanf("%d %d", &a, &b);
		gmap[a][b] = gmap[b][a] = true;
	}
	
	init();
	
	//for(int i=1; i<=N; i++) printf("%d ", groups[i]);
	//printf("\n");
	
	scanf("%d", &Q);
	solve();
	printf("\n");
	
	return 0;
}
