#include <cstdio>
#include <cstring>
#include <stack>

#define MAXN 1000

struct node{
    int ecnt;
    int edges[MAXN];
    int c;
}nodes[MAXN];

void AddEdge(int a, int b);
void RemoveEdge(int a, int b);
void RemoveEdgeAtoB(int a, int b);

void UpdateC(int n);
void UpdateCtoX(int n, int x);
void DFS(int n);

int N, M, Q;
int cuc = 1;

std::stack<int> dfss;

bool visited[MAXN];

int main()
{
    memset(nodes, 0, sizeof(nodes));

    scanf("%d %d", &N, &M);

    int a, b;
    for(int i = 0;i < M;i++)
    {
        scanf("%d %d", &a, &b);
        a--;b--;

        AddEdge(a, b);
    }

    //set up components
    memset(visited, 0, sizeof(visited));

    for(int i = 0;i < N;i++)
    {
        if(!visited[i])
        {
            DFS(i);

            while(!dfss.empty())
            {
                //printf("adding %d to %d\n", dfss.top(), cuc);
                nodes[dfss.top()].c = cuc;
                dfss.pop();
            }

            cuc++;
        }
    }

    scanf("%d", &Q);

    //begin queries
    int c;
    for(int q = 0;q < Q;q++)
    {
        scanf("%d %d %d", &c, &a, &b);

        a--;b--;

        switch(c)
        {
            case 1:
                if(nodes[a].c == nodes[b].c)
                {
                    printf("1");
                }
                else
                {
                    printf("0");
                }
                break;
            case 2:
                if(nodes[a].c != nodes[b].c)
                {
                    UpdateCtoX(b, nodes[a].c);
                }
                AddEdge(a, b);
                break;
            case 3:
                RemoveEdge(a, b);
                UpdateC(a);
                break;
        }
    }

    return 0;
}

void UpdateC(int n)
{
    memset(visited, 0, sizeof(visited));

    DFS(n);

    while(!dfss.empty())
    {
        //("adding %d to %d\n", dfss.top(), cuc);
        nodes[dfss.top()].c = cuc;
        dfss.pop();
    }

    cuc++;
}

void UpdateCtoX(int n, int x)
{
    memset(visited, 0, sizeof(visited));

    DFS(n);

    while(!dfss.empty())
    {
        //printf("adding %d to %d\n", dfss.top(), cuc);
        nodes[dfss.top()].c = x;
        dfss.pop();
    }
}

void DFS(int n)
{
    visited[n] = true;
    dfss.push(n);

    for(int i = 0;i < nodes[n].ecnt;i++)
    {
        if(!visited[nodes[n].edges[i]])
            DFS(nodes[n].edges[i]);
    }
}

void AddEdge(int a, int b)
{
    nodes[a].edges[nodes[a].ecnt] = b;
    nodes[b].edges[nodes[b].ecnt] = a;

    nodes[a].ecnt++;
    nodes[b].ecnt++;
}

void RemoveEdge(int a, int b)
{
    RemoveEdgeAtoB(a, b);
    RemoveEdgeAtoB(b, a);
}

void RemoveEdgeAtoB(int a, int b)
{
    for(int i = 0;i < nodes[a].ecnt;i++)
    {
        if(nodes[a].edges[i] == b)
        {
            nodes[a].edges[i] = nodes[a].edges[nodes[a].ecnt-1];
            nodes[a].ecnt--;
            return;
        }
    }
}
