#include <iostream>
#include <stdio.h>
#include <string.h>
#include <queue>
#include <set>

using namespace std;

const int MAXN = 1 << 10;

int n, m, q;
set<int> g[MAXN];
int rt[MAXN];
bool mustFix;

void read() {
    int x, y;

    scanf("%d %d", &n, &m);
    for(int i = 0; i < m; i ++) {
        scanf("%d %d", &x, &y);
        g[x].insert(y);
        g[y].insert(x);
    }
}

void bfs(int root) {
    queue<int> q;

    q.push(root);
    rt[root] = root;
    while(!q.empty()) {
        int tmp = q.front();
        q.pop();

        for(set<int> :: iterator it = g[tmp].begin(); it != g[tmp].end(); it ++) {
            int nxt = *it;
            if(!rt[nxt]) {
                rt[nxt] = root;
                q.push(nxt);
            }
        }
    }
}

void fix() {
    memset(rt, 0, sizeof(rt));

    for(int i = 1; i <= n; i ++)
        if(!rt[i])
            bfs(i);
}

int getRoot(int v) {
    int root = v;
    while(root != rt[root])
        root = rt[root];
    int up;
    while(v != root) {
        up = rt[v];
        rt[v] = root;
        v = up;
    }
    return root;
}

void solve() {
    int cmd, x, y;

    fix();

    scanf("%d", &q);
    for( ; q; q --) {
        scanf("%d %d %d", &cmd, &x, &y);
//        cout << cmd << " " << x << " " << y << endl;
        if(cmd == 1) {
            if(mustFix) {
                fix();
                mustFix = false;
            }
            int r1 = getRoot(x);
            int r2 = getRoot(y);
            if(r1 == r2) printf("1");
            else printf("0");
        }
        else if(cmd == 2) {
            int r1 = getRoot(x);
            int r2 = getRoot(y);
            if(r1 != r2) rt[r1] = r2;
        }
        else {
            if(g[x].find(y) != g[x].end()) g[x].erase(y);
            if(g[y].find(x) != g[y].end()) g[y].erase(x);
            mustFix = true;
        }
    }
    printf("\n");
}

int main()
{
    read();
    solve();

    return 0;
}
