#include <cstdio>
#include <vector>
using namespace std;

bool *used;
vector <int> *graf;
int ntowns;

bool check (int pos, int dest);
bool dfs(int pos, int dest);
void erase (vector<int> *v, int n);

int main()
{
   int nways, ncalls, callnum, coord1, coord2;
   scanf ("%d%d", &ntowns, &nways);
   graf = new vector <int> [ntowns];
   int in1, in2;
   for (int i=0; i<nways; i++)
   {
      scanf("%d%d", &in1, &in2);
      graf[in1-1].push_back(in2-1);
      graf[in2-1].push_back(in1-1);
   }
   scanf("%d", &ncalls);

   for (int i=0; i<ncalls; i++)
   {
      scanf("%d %d %d", &callnum, &coord1, &coord2);
      if (callnum==1)
      {
         printf ("%d", check (coord1-1, coord2-1));
      }
      if (callnum==2)
      {
         graf[coord1-1].push_back(coord2-1);
         graf[coord2-1].push_back(coord1-1);
      }
      if (callnum==3)
      {
         erase (&graf[coord1-1], coord2-1);
         erase (&graf[coord2-1], coord1-1);
      }
   }
   printf("\n");
   return 0;
}

bool check (int pos, int dest)
{
   used = new bool[ntowns];
   for (int i=0; i<ntowns; i++)
      used[i]=0;
   return dfs (pos, dest);
}

bool dfs (int pos, int dest)
{
   for (int i=0; i<graf[pos].size(); i++)
      if(!used[graf[pos][i]])
      {
         if (graf[pos][i]==dest)
            return 1;
         used[graf[pos][i]]=1;
         if (dfs (graf[pos][i], dest))
            return 1;
      }
   return 0;
}

void erase (vector<int> *v, int n)
{
   for (int i=0; i<(*v).size(); i++)
      if ((*v)[i]==n)
      {
         (*v).erase((*v).begin()+i);
      }
}
